X11 needs minimal multi monitor mode support

11/25/2013 09:08 PM - Zbigniew Rebacz

Status: Approved Start date: 11/25/2013

Priority: Normal Due date:

Assignee: Miroslav Fidler % Done: 100%

Category: CtrlCore Estimated time: 0.00 hour

Target version: Spent time: 0.00 hour

Description

I implemented minimal multi monitor based on the tracking position of the mouse cursor. It doesn't change Ultimate++ overall schemat

and works great. Two methods are implemented: "Ctrl::GetDefaultWindowRect()" and "Ctrl::GetPrimaryWorkArea()". Of course some

other methods need update as well like "TopWindow::CenterRect(Ctrl *owner)".

P.S.

This update uses Xinerama the X11 extension. If operating system does not recognize this extension Ultimate++ works normally.

Personally, I think that this patch should eliminate most of multi monitors problems on X11.

Related issues:

Follows Bug # 568: Ctrl::GetDefaultWindowRect on X11 dosen't recognize multi ... Rejected 11/12/2013

History

#1 - 11/25/2013 09:16 PM - Zbigniew Rebacz

- File X11Gui.h added

#2 - 11/26/2013 01:49 AM - Zbigniew Rebacz

- File CtrlCore.upp added

I think we need to link with Xinerama...

#3 - 11/26/2013 01:53 AM - Zbigniew Rebacz

Corrigendum: Xinerama is linking by default when GTK is on. When we are using pure X11 we need to link with Xinerama...

#4 - 11/26/2013 12:44 PM - Zbigniew Rebacz

- Status changed from Ready for QA to New

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

I need some time to fix "TopWindow::CenterRect" method...

#5 - 11/26/2013 12:45 PM - Zbigniew Rebacz

- % Done changed from 100 to 80

#6 - 11/26/2013 03:52 PM - Zbigniew Rebacz

- File deleted (X11Top.cpp)

#7 - 11/26/2013 04:02 PM - Zbigniew Rebacz
- File X11Top.cpp added

- % Done changed from 80 to 90

#8 - 11/26/2013 06:18 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#9 - 11/26/2013 06:20 PM - Zbigniew Rebacz

- File X11App.cpp added

- Status changed from New to Ready for QA

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

- % Done changed from 90 to 100

Done...

P.S.

I added additional mouse detection in "TopWindow::GetDefaultWindowRect()"!

#10 - 12/02/2013 06:57 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#11 - 12/02/2013 06:58 PM - Zbigniew Rebacz

- File X11App.cpp added

#12 - 12/03/2013 09:14 AM - Miroslav Fidler

- Status changed from Ready for QA to Patch ready

#13 - 12/13/2013 09:39 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#14 - 12/13/2013 09:41 PM - Zbigniew Rebacz

- File X11App.cpp added

Code refactoring...

#15 - 12/13/2013 09:42 PM - Zbigniew Rebacz

- File deleted (X11Top.cpp)

#16 - 12/13/2013 09:50 PM - Zbigniew Rebacz

- File X11Top.cpp added

Now, serialization supports new multi monitor mode.

Rect limit = GetPrimaryScreenArea();

insted of:

Rect limit = GetWorkArea(); // <- We can not limit to specific work area! (Because, we can have more than one!)
#17 - 12/14/2013 02:34 AM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#18 - 12/14/2013 02:36 AM - Zbigniew Rebacz

- File X11App.cpp added

GetVirtualWorkArea is implemented under X11... (The behavior is the same as the win32 version)

#19 - 12/14/2013 02:36 AM - Zbigniew Rebacz

- File deleted (X11Top.cpp)

#20 - 12/14/2013 02:38 AM - Zbigniew Rebacz

- File X11Top.cpp added

GetVirtualWorkArea insted of GetPrimaryScreenArea() in serialization code (The behavior is the same as the win32 version).

#21 - 12/18/2013 12:29 AM - Zbigniew Rebacz

- Status changed from Patch ready to In Progress

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

#22 - 12/19/2013 02:42 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#23 - 12/19/2013 02:45 PM - Zbigniew Rebacz

- File X11App.cpp added

- Status changed from In Progress to Patch ready

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

I implemented two following methods under X11: GetPrimaryScreenArea and GetVirtualScreenArea.

#24 - 12/19/2013 03:03 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#25 - 12/19/2013 03:04 PM - Zbigniew Rebacz

- File X11App.cpp added

#26 - 12/19/2013 04:04 PM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#27 - 12/19/2013 04:05 PM - Zbigniew Rebacz

- File X11App.cpp added

#28 - 12/19/2013 11:05 PM - Zbigniew Rebacz

- Status changed from Patch ready to In Progress

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz
#29 - 12/21/2013 02:36 AM - Zbigniew Rebacz

- File deleted (X11App.cpp)

#30 - 12/21/2013 02:43 AM - Zbigniew Rebacz

- File X11App.cpp added

- Status changed from In Progress to Patch ready

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

Achieved better performance by using static variables. Small digression: calling "XineramaQueryScreens" over and over again can be painful for real time

applications!

#31 - 12/21/2013 02:45 AM - Zbigniew Rebacz

BTW, This patch is also compatible with u++ documentation.

#32 - 12/21/2013 06:23 PM - Zbigniew Rebacz

- Status changed from Patch ready to In Progress

- Assignee changed from Miroslav Fidler to Zbigniew Rebacz

#33 - 12/21/2013 07:43 PM - Zbigniew Rebacz

- Status changed from In Progress to Patch ready

- Assignee changed from Zbigniew Rebacz to Miroslav Fidler

#34 - 12/26/2013 11:33 AM - Miroslav Fidler

- Status changed from Patch ready to Approved

Files

X11Gui.h 6.41 KB 11/25/2013 Zbigniew Rebacz

CtrlCore.upp 2.39 KB 11/26/2013 Zbigniew Rebacz

X11Top.cpp 13.7 KB 12/14/2013 Zbigniew Rebacz

X11App.cpp 12.9 KB 12/21/2013 Zbigniew Rebacz
